<?php

namespace Teknisa\CMP\Modules\V1\Controllers; 

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class CMP05000 extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $qr2Strategy;
    protected $stNomeRel;

    public function __construct($reportService, $entityManager, $qr2Strategy) {
        
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;

    }

    protected $reportMapping = array();
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array(
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                    array(
                        'TDTINI'      => 'P_TDTINI',
                        'TDTFIM'      => 'P_TDTFIM',
                        'CDFILSOLI'   => 'L_CDFILSOLI',
                        'CDFILLAN'    => 'L_CDFILLANC',
                        'NRSOLI'      => 'L_NRSOLI',
                        'CDREGIAO'    => 'L_REGIAO',
                        'CDGRUPFILI'  => 'L_FILGRUPFILI',
                        'DTINI'       => 'P_DTINI',
                        'DTFIM'       => 'P_DTFIM',
                        'CDPRODINI'   => 'P_PRODINI',
                        'CDPRODFIN'   => 'P_PRODFIN',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
                        'IMPRIME'     => 'P_IMPRIMEOBS',
                    ),
            ),
    );

    }
}